/*
 * Event1.h - Header file for the Event application for Windows 3.0
 *
 *
 * 04/17/91 1.00 - Kanhom Ng 
 *
 * ---------------------------------------------------------
 * Copyright (C) 1991 Kanhom Ng.  All rights reserved.
 * ---------------------------------------------------------
 *
 *	P.O. Box 391176, Mountain View, CA 94039
 *
 */	

#define SHOWERR(f,h,s) if ( !(f) ) { MessageBox( h, s, "Event", MB_OK ); }

#define IDM_NEW        100     /* new menu item id */
#define IDM_DELETE     101     /* delete menu item id */
#define IDM_EXIT       102     /* exit item id */

#define ID_DATE        100     /* control id for Date */
#define ID_TIME        101     /* control id for Time */
#define ID_DESC        102     /* control id for Description */
#define ID_CMDLINE     103     /* control id for Command Line */
#define ID_RUNRECORDER 104     /* control id for
                                    "Run Recorder" checkbox */
#define ID_FILE        105     /* control id for
                                    recorder file name */
#define ID_MACRONAME   106     /* control id for
                                    recorder macro name */

typedef struct
{
    BOOL   fRecorder;    /* do we replay a macro? */
    char   szFile[80];   /* recorder file name */
    char   szMacro[80];  /* macro's name in the recorder file */
    BOOL   fCalled;      /* boolean indicator if it is called */
    struct tm  tm;       /* time structure for the event */
    char   szDesc[ 40 ]; /* description string */
    char   szCmd[ 60 ];  /* command line string */
} EVENTREC, FAR * LPEVENTREC, *PEVENTREC;
